﻿
Public Class FrmBuscarProductos
    Dim ListaProductos As New List(Of Producto)
    Public Delegate Sub TraerProducto(product As Producto)
    Public Event EnviarProducto As TraerProducto
    Private Sub FrmBuscarProductos_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try
            Me.DgvProductos.AutoGenerateColumns = False
            LlenarProductos()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub LlenarProductos()
        For i As Integer = 1 To 50
            Dim prod As New Producto
            prod.IdProducto = i
            prod.NombreProducto = "PRODUCTO " + i.ToString
            prod.Precio = 1.5 * i
            prod.Iva = 0.18
            ListaProductos.Add(prod)
        Next
        Me.DgvProductos.DataSource = ListaProductos
        Me.DgvProductos.Columns(0).DataPropertyName = "IdProducto"
        Me.DgvProductos.Columns(1).DataPropertyName = "NombreProducto"
        Me.DgvProductos.Columns(2).DataPropertyName = "Precio"
        Me.DgvProductos.Columns(3).DataPropertyName = "Iva"
    End Sub

    Private Sub BtnCerrar_Click(sender As Object, e As EventArgs) Handles BtnCerrar.Click
        Me.Close()
    End Sub

    Private Sub TxtProducto_TextChanged(sender As Object, e As EventArgs) Handles TxtProducto.TextChanged
        Dim ListaFiltrada = From prod In ListaProductos Where prod.NombreProducto.StartsWith(Me.TxtProducto.Text, StringComparison.InvariantCultureIgnoreCase) Select prod
        Me.DgvProductos.DataSource = ListaFiltrada.ToList
    End Sub

    Private Sub DgvProductos_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DgvProductos.CellDoubleClick
        Try
            Dim prod = New Producto
            prod.IdProducto = Convert.ToInt32(Me.DgvProductos.Item(0, Me.DgvProductos.CurrentRow.Index).Value)
            prod.NombreProducto = Me.DgvProductos.Item(1, Me.DgvProductos.CurrentRow.Index).Value.ToString
            prod.Precio = Convert.ToDecimal(Me.DgvProductos.Item(2, Me.DgvProductos.CurrentRow.Index).Value)
            prod.Iva = Convert.ToDecimal(Me.DgvProductos.Item(3, Me.DgvProductos.CurrentRow.Index).Value)
            RaiseEvent EnviarProducto(prod)
            Me.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
End Class